
local C = Winning_Constants
local M = {}
Winning_Blizzard = M

-- Blizzard brings some functions up to global namespace for
-- convenience.
if os then
    M.format = string.format
    M.time = os.time
    M.date = os.date
else
    M.format = string.format
    M.time = time
    M.date = date
end


M.GetRealmName = function()
    return "Exodar"
end


M.DEFAULT_CHAT_FRAME = {
    AddMessage = function(self, msg) 
        if C.ADDON_DEBUG then
            print(string.format("MOCK CHAT: %s", msg))
            -- Return the chat message for assertion
            -- in tests.
        end
        return msg
    end
}


M.SendChatMessage = function(msg, channel)
    local m = string.format("%s: %s", channel, msg)
    DEFAULT_CHAT_FRAME:AddMessage(m)
end


M.GetNumBattlefieldScores = function()
    -- simulate 10v10
    return 20
end



-- name, killingBlows, honorableKills, deaths, honorGained, faction, race, class, classToken, damageDone, healingDone, bgRating, ratingChange, preMatchMMR, mmrChange, talentSpec = GetBattlefieldScore(idx)
local _mock_battlefield_scores = {}

-- Alliance
_mock_battlefield_scores[1] = {"Lolotov-Exodar", 25, 45, 0, 127, 1, 'Human', 'Warlock', 'Warlock', 9999999, 876543, 0, 0, 0, 0, "Affliction"}
_mock_battlefield_scores[2] = {"Lolotov-Exodar", 25, 45, 0, 127, 1, 'Human', 'Warlock', 'Warlock', 9999999, 876543, 0, 0, 0, 0, "Affliction"}
_mock_battlefield_scores[3] = {"Lolotov-Exodar", 25, 45, 0, 127, 1, 'Human', 'Warlock', 'Warlock', 9999999, 876543, 0, 0, 0, 0, "Affliction"}
_mock_battlefield_scores[4] = {"Lolotov-Exodar", 25, 45, 0, 127, 1, 'Human', 'Warlock', 'Warlock', 9999999, 876543, 0, 0, 0, 0, "Affliction"}
_mock_battlefield_scores[5] = {"Lolotov-Exodar", 25, 45, 0, 127, 1, 'Human', 'Warlock', 'Warlock', 9999999, 876543, 0, 0, 0, 0, "Affliction"}
_mock_battlefield_scores[6] = {"Lolotov-Exodar", 25, 45, 0, 127, 1, 'Human', 'Warlock', 'Warlock', 9999999, 876543, 0, 0, 0, 0, "Affliction"}
_mock_battlefield_scores[7] = {"Lolotov-Exodar", 25, 45, 0, 127, 1, 'Human', 'Warlock', 'Warlock', 9999999, 876543, 0, 0, 0, 0, "Affliction"}
_mock_battlefield_scores[8] = {"Lolotov-Exodar", 25, 45, 0, 127, 1, 'Human', 'Warlock', 'Warlock', 9999999, 876543, 0, 0, 0, 0, "Affliction"}
_mock_battlefield_scores[9] = {"Lolotov-Exodar", 25, 45, 0, 127, 1, 'Human', 'Warlock', 'Warlock', 9999999, 876543, 0, 0, 0, 0, "Affliction"}
_mock_battlefield_scores[10] = {"Lolotov-Exodar", 25, 45, 0, 127, 1, 'Human', 'Warlock', 'Warlock', 9999999, 876543, 0, 0, 0, 0, "Affliction"}

-- Horde
_mock_battlefield_scores[11] = {"Lolotov-Area52", 25, 45, 0, 127, 0, 'Human', 'Warlock', 'Warlock', 9999999, 876543, 0, 0, 0, 0, "Affliction"}
_mock_battlefield_scores[12] = {"Gnorgana-Area52", 25, 45, 0, 127, 0, 'Human', 'Priest', 'Priest', 9999999, 876543, 0, 0, 0, 0, "Discipline"}
_mock_battlefield_scores[13] = {"Oghma-Area52", 25, 45, 0, 127, 0, 'Human', 'Warlock', 'Warlock', 9999999, 876543, 0, 0, 0, 0, "Survival"}
_mock_battlefield_scores[14] = {"Regnibla-Area52", 25, 45, 0, 127, 0, 'Human', 'Druid', 'Druid', 9999999, 876543, 0, 0, 0, 0, "Balance"}
_mock_battlefield_scores[15] = {"Tanks-Area52", 25, 45, 0, 127, 0, 'Human', 'Paladin', 'Paladin', 9999999, 876543, 0, 0, 0, 0, "Retribution"}
_mock_battlefield_scores[16] = {"Syntaxx-Darkspear", 25, 45, 0, 127, 0, 'Human', 'Warlock', 'Warlock', 9999999, 876543, 0, 0, 0, 0, "Destruction"}
_mock_battlefield_scores[17] = {"Bushidobert-Thrall", 25, 45, 0, 127, 0, 'Human', 'Panderan', 'Panderan', 9999999, 876543, 0, 0, 0, 0, "Windwalker"}
_mock_battlefield_scores[18] = {"Kaesden-Thrall", 25, 45, 0, 127, 0, 'Human', 'DeathKnight', 'DeathKnight', 9999999, 876543, 0, 0, 0, 0, "Frost"}
_mock_battlefield_scores[19] = {"Nezumi-Darkspear", 25, 45, 0, 127, 0, 'Human', 'Hunter', 'Hunter', 9999999, 876543, 0, 0, 0, 0, "Survival"}
_mock_battlefield_scores[20] = {"Zadok-Darkspear", 25, 45, 0, 127, 0, 'Human', 'Priest', 'Priest', 9999999, 876543, 0, 0, 0, 0, "Shadow"}

M.GetBattlefieldScore = function(idx)
    local t = _mock_battlefield_scores[idx]
    return t[1], t[2], t[3], t[4], t[5], t[6], t[7], t[8], t[9], t[10], t[11], t[12], t[13], t[14], t[15], t[16], t[17], t[18], t[19], t[20]
end


M.GetSpecialization = function()
    print("Not implemented: GetSpecialization")
end


M.GetSpecializationInfo = function()
    local id = 45
    local name = 'Frost'
    local description = "Frosty frost."
    local icon = 'file.png'
    local background = 'otherfile.png'
    local role = 'HEALER'
    return id, name, description, icon, background, role
end


M.GetBattlefieldWinner = function()
    -- 1 is horde or alliance?
    return 1
end


M.GetBattlefieldInstanceRunTime = function()
    return 1028000
end


M.SetMapToCurrentZone = function()
    print("Not implemented: SetMapToCurrentZone")
end


M.GetCurrentMapAreaID = function()
    print("Not implemented: GetCurrentMapAreaID")
end


M.GetCurrentArenaSeason = function()
    print("Not implemented: GetCurrentArenaSeason")
end


M.IsRatedBattleground = function()
    print("Not implemented: IsRatedBattleground")
end


M.GetBattlegroundInfo = function()
    print("Not implemented: GetBattlegroundInfo")
end

-- Used by LibGraph
M.debugstack = function()
    return "AddOns\\aLibGraph-2.1.lua"
end


-- Used by LibStub
M.strmatch = function(s, ex)
    return string.match(s, ex)
end


--[[
--Mock out all Blizzard functions if not running in game.
--]]
M.mock_if_missing = function()
    for k, v in pairs(M) do
        if k ~= 'mock_if_missing' then
            if _G[k] == nil then
                print(string.format("Did not find '%s', mocking.", k))
                _G[k] = M[k]
            else
                print(string.format("Found global '%s', not mocking.", k))
            end
        end
    end
end

return M
