#!/usr/bin/env bash

DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"

# When the game loads the addon, it uses the TOC to basically do this
# part.
# - Find all directories
# - ignore the .git directory
# - ignore '.' and '..' special directory
# - stitch all lines together with a special char
# - replace the special char with the LUA_PATH pattern for lua files
ADDON_DIRS=$(find . -type d | grep -v git | grep '/' | tr '\n' '!' | sed -e 's#!#/?.lua;#g')

# signify to lua the special ending of ';;' which tells
# it to use previous default value for LUA_PATH
export LUA_PATH="$ADDON_DIRS;"

time lua tests/tests.lua
